  PROGRAM

!*******************************************************
! DDE Client Demo Program by:
! Larry Teames
! CREATIVE PC SOLUTIONS
! CIS: 73150,104
! (602) 963-3506
!*******************************************************

CrLf     EQUATE('<13,10>')

 INCLUDE('EQUATES.CLW')
 INCLUDE('KEYCODES.CLW')


    MAP
      DDEColdDemoProc                                 ! COLD Client
      DDEHotDemoProc                                  ! HOT Client
!      MODULE('Win API')
!        FindWindow(*CSTRING,*CSTRING),SHORT,RAW,PASCAL ! Find an Running App
!        SetFocus(USHORT),USHORT,PASCAL                 ! Set Input Focus to Window specified
!      END
!      INCLUDE('WINDOWS.CLW')
      INCLUDE('DDE.CLW')
    END


WINCLASS    CSTRING(80)    ! Used by FindWindow()
WINTITLE    CSTRING(80)    ! Used by FindWindow()

DDEHC       BYTE                                     ! TRUE=HOT Client Active
DDECC       BYTE                                     ! TRUE=COLD Client Active



BaseScreen APPLICATION('DDE CLIENT Demo'),AT(0,0,180,220),FONT('Arial',10,,FONT:regular),HLP('DDE Library Reference'), |
         SYSTEM,DOUBLE
       MENUBAR
         MENU('&Windows'),STD(STD:WindowList)
           ITEM('&Tile'),USE(?Tile),STD(STD:TileWindow)
           ITEM('&Cacade'),USE(?Cascade),STD(STD:CascadeWindow)
         END
         MENU('&Help'),LAST,MSG('Windows Help')
           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
         END
       END
       TOOLBAR,AT(0,0,180,17)
         BUTTON('&COLD Demo'),AT(2,1,53,15),USE(?StartColdClient)
         BUTTON('Start &SERVERS'),AT(113,1,66,15),USE(?StartServers)
         BUTTON('&HOT Demo'),AT(58,1,53,15),USE(?StartHotClient)
       END
     END



WinExecStat      USHORT
CmdLine          CSTRING(32)




  CODE
  OPEN(BaseScreen)

  HELP('CWHELP.HLP')

  ACCEPT

    CASE EVENT()
      OF EVENT:OpenWindow
        WINCLASS = 'ClaWinClass1'               ! set the "Class" name,
        WINTITLE = 'DDE SERVER Demo'            ! set the "Title" name,
        SDEMO# = FindWindow(WINCLASS, WINTITLE) ! is DDEDEMOS.EXE running?
        IF ~SDEMO#                              ! If not:
          CASE MESSAGE('Start the SERVER Application?','DDE CLIENT Demo',ICON:Question,BUTTON:Yes+BUTTON:No,BUTTON:Yes) ! ask user
            OF BUTTON:Yes                           ! if user answers Yes
              CmdLine = 'DDEDEMOS.EXE'
              WinExecStat = WinExec(CmdLine,2)      ! Start the Server App
              IF WinExecStat < 32
                X# = MESSAGE('Unable to start DDEDEMOS.EXE','Problem',ICON:Exclamation,BUTTON:Ok)
              END
          END
        END


    END

    CASE ACCEPTED()
      OF ?StartColdClient
        IF ~DDECC
          DDECC = START(DDEColdDemoProc)  ! Start COLD Client if not active
        END

      OF ?StartHotClient
        IF ~DDEHC
          DDEHC = START(DDEHotDemoProc)   ! Start HOT Client if not active
        END

      OF ?StartServers
        WINCLASS = 'ClaWinClass1'               ! set the "Class" name,
        WINTITLE = 'DDE SERVER Demo'            ! set the "Title" name,
        SDOMO# = FindWindow(WINCLASS, WINTITLE) ! is DDEDEMOS.EXE running?
        IF ~SDOMO#                              ! If not:
          CmdLine = 'DDEDEMOS.EXE'
          WinExecStat = WinExec(CmdLine,2)      ! Start the Server App
          IF WinExecStat < 32
            X# = MESSAGE('Unable to start DDEDEMOS.EXE','Problem',ICON:Exclamation,BUTTON:Ok)
          END
        ELSE
          X# = MESSAGE('DDEDEMOS.EXE is already running','Information',ICON:Exclamation)
        END

    END
  END



DDEHotDemoProc     PROCEDURE

! HOT connection variables
HotChannel       ULONG
HotResp          STRING(1000)
HotText          STRING(1000)


HotClientScr WINDOW('DDE HOT CLIENT Demo'),AT(1,122,176,54),FONT('Arial',10,,FONT:regular),SYSTEM,GRAY, |
         NOFRAME
       MENUBAR
         MENU('Edit'),USE(?EditMenu)
           ITEM('Undo'),USE(?UndoText),KEY(CtrlZ),STD(STD:Undo)
           ITEM('Cu&t'),USE(?CutText),KEY(CtrlX),STD(STD:Cut)
           ITEM('Copy'),USE(?CopyText),KEY(CtrlC),STD(STD:Copy)
           ITEM('Paste'),USE(?PasteText),KEY(CtrlV),STD(STD:Paste)
         END
       END
       BUTTON('&Start'),AT(3,4,33,14),USE(?StartHot)
       BUTTON('Sto&p'),AT(3,21,33,14),USE(?StopHot)
       BUTTON('-'),AT(4,37,14,13),USE(?Faster)
       BUTTON('+'),AT(21,37,14,13),USE(?Slower)
       TEXT,AT(39,4,135,46),USE(HotText),HVSCROLL
     END



  CODE

  OPEN(HotClientScr)

  ACCEPT

    CASE EVENT()

      OF EVENT:OpenWindow

      OF EVENT:DDEData                  ! A Server sent some data
        IF DDEAPP() = 'HotDemo' AND DDETOPIC() = 'HotTopic' AND DDEITEM() = 'HotData' ! is it what we want?
          HotLines# += 1
          IF HotLines# > 4                                ! maintain last 4 lines
            CRLF2# = INSTRING('<13,10>',HotText,1)        ! by removing 1st line
            HotText = SUB(HotText,CRLF2#+2,SIZE(HotText)) ! from existing
          END
          HotText = CLIP(HotText) & CrLf & HotResp        ! then tag on new data
          DISPLAY(?HotText)                               ! and display it
        END

      OF EVENT:Accepted
        CASE FIELD()

          OF ?StartHot
            IF ~HotChannel          ! if not currently connected to HOT Server
              HotChannel = DDEClient('HotDemo','HotTopic') ! Connect to HOT Server
              IF HotChannel                                          ! If successful
                HotText = 'HotDemo:HotTopic = Channel ' & HotChannel ! Display Channel nbr
                DISPLAY(?HotText)
                HotLines# = 1
              ELSE
                x# = MESSAGE('DDEDEMOS.EXE (HOTSERVER) must be running','Problem',ICON:Exclamation)
              END
            END
            IF HotChannel                                    ! IF connection exists
              DDEREAD(HotChannel,DDE:Auto,'HotData',HotResp) ! Start "HOT" activity
              HotActive# = 1                                 ! and note its active
            END



          OF ?StopHot
            IF HotChannel                                    ! If HOT connection exists
              IF HotActive#                                  ! and is currently active
                HotActive# = 0                               ! Turn off active flag
                DDEREAD(HotChannel,DDE:Remove,'HotData')     ! stop activity
                IF CLIP(HotResp) <> '*ReStart*' AND LEN(CLIP(HotResp)) > 0  ! If not resetting the timing
                  ?HotText{PROP:Text} = '* STOPPED by User *' & CrLf & 'Press START to Restart...' ! display a "stopped" message
                  DISPLAY(?HotText)
                END
                HotResp = ''
              END
            END


          ! DDEPOKE() is used to send "unsolicited data" to a DDE Server.
          ! The server must be programmed to recognize a DDEPOKE, and to
          ! to do something with the data sent.  The second parameter
          ! indicates the DDEITEM being sent, and parameter is the
          ! actual "data" being sent.
          !
          OF ?Slower
            DDEPOKE(HotChannel,'Slower',1)

          OF ?Faster
            DDEPOKE(HotChannel,'Faster',1)

        END


      ! Whenever a "connected" DDE Server is closed, the DDEClosed EVENT
      ! is sent to inform the DDE Client of the closedown.
      !
      OF EVENT:DDEClosed
        z# = MESSAGE('HOT Server Closed!','Information',ICON:Exclamation)
        HotText = ''
        DISPLAY(?HotText)

      OF EVENT:CloseWindow
        Break
    END
  END
  IF HotChannel                    ! If HOT link is active
    DDECLOSE(HotChannel)           ! Close it
  END
  CLOSE(HotClientScr)
  DDEHC = 0                        ! HOT Client no longer active




DDEColdDemoProc     PROCEDURE


Server:Queue     QUEUE,PRE(SER)    ! Queue of Active Servers
ServerID           STRING(8)       ! Server APP Name
ServerActive       STRING(1)       ! not used in this demo
ServerTopic        STRING(32)      ! not used in this demo
ServerChannel      ULONG           ! not used in this demo
                 END


Item:Queue       QUEUE,PRE(ITM)    ! valid items for the current server
ItemName           STRING(16)
                 END


ColdText         STRING(1000)
ColdRequest      STRING(33)
ColdServer       CSTRING(9)
ColdChannel      ULONG
ColdResp         STRING(1000)
ColdTopic        CSTRING(17)
ColdCommand      CSTRING(33)


ColdClientScr WINDOW('DDE COLD CLIENT Demo'),AT(2,1,176,95),FONT('Arial',10,,400),SYSTEM,GRAY,NOFRAME
         MENUBAR
           MENU('Edit'),USE(?EditMenu)
             ITEM('Undo'),USE(?UndoText),KEY(CtrlZ),STD(STD:Undo)
             ITEM('Cu&t'),USE(?CutText),KEY(CtrlX),STD(STD:Cut)
             ITEM('Copy'),USE(?CopyText),KEY(CtrlC),STD(STD:Copy)
             ITEM('Paste'),USE(?PasteText),KEY(CtrlV),STD(STD:Paste)
           END
         END
         COMBO(@S8),AT(30,3,90,12),USE(ColdServer),VSCROLL,FORMAT('[30L~ServerID~@S8@]'),DROP(5),FROM(Server:Queue)
         BUTTON('&ReLoad Svrs'),AT(123,2,50,13),USE(?ReloadServers)
         BUTTON('&Server'),AT(1,3,27,12),USE(?ServerButton)
         COMBO(@S16),AT(30,17,143,12),USE(ColdRequest),VSCROLL,FORMAT('[60L@S16@]'),DROP(3),FROM(Item:Queue)
         BUTTON('&Item'),AT(1,17,27,12),USE(?ItemButton)
         ENTRY(@s32),AT(30,31,143,12),USE(ColdCommand)
         BUTTON('E&xec'),AT(1,31,27,12),USE(?ExecButton)
         TEXT,AT(2,46,172,47),USE(ColdText),HVSCROLL
       END



  CODE

  OPEN(ColdClientScr)

  ACCEPT

    CASE EVENT()

      OF EVENT:OpenWindow       ! When window opens
        DO LoadServerQueue      ! Load queue of valid servers

      OF EVENT:GainFocus
      OROF EVENT:Selected
        CASE FOCUS()
          OF ?ColdServer        ! If user re-selects the Server ComboBox
            DO LoadServerQueue  ! re-load the queue of valid servers
        END


      OF EVENT:Accepted
        CASE ACCEPTED()

          OF ?ReloadServers     ! User requested a re-load of valid servers
            SELECT(?ColdServer) ! so EVENT:Selected causes the re-load
            CYCLE

          OF ?ServerButton
            IF ~ColdServer           ! If no server name given
              SELECT(?ColdServer)    ! its an error
              CYCLE
            END
            IF ColdChannel           ! If a link already exists
              DDEClose(ColdChannel)  ! close it
              ColdChannel = 0
            END
            ColdChannel = DDEClient(CLIP(ColdServer))  ! start a new link
            ColdText = ColdServer & ': ' & ColdChannel
            ColdLines# = 1
            DISPLAY(?ColdText)      ! display the server name & channel#
            FREE(Item:Queue)
            ColdRequest = ''        ! clear other fields
            DISPLAY(?ColdRequest)
            ColdCommand = ''        ! clear other fields
            DISPLAY(?ColdCommand)
            IF ColdChannel          ! if link exists, load valid Item Queue
              ITM:ItemName = 'Topics';    ADD(Item:Queue,ITM:ItemName)
              ITM:ItemName = 'SysItems';  ADD(Item:Queue,ITM:ItemName)
              CASE UPPER(CLIP(ColdServer))
                OF 'COLDDEMO'
                  ITM:ItemName = 'ColdData1'; ADD(Item:Queue,ITM:ItemName)
                  ITM:ItemName = 'ColdData2'; ADD(Item:Queue,ITM:ItemName)

                OF 'HOTDEMO'
                  ITM:ItemName = 'HotData';   ADD(Item:Queue,ITM:ItemName)

                OF 'PROGMAN'
                  ITM:ItemName = 'ProgMan';   ADD(Item:Queue,ITM:ItemName)

              END
            END


          OF ?ItemButton
            IF ~ColdRequest         ! If no Item given
              SELECT(?ColdRequest)  ! get one
              CYCLE
            END
            LOOP I# = 1 TO LEN(CLIP(ColdRequest))  ! correct bad chars derived from a "CLIPBOARD PASTE" operation
              IF VAL(ColdRequest[I#]) < 32 OR |
                 VAL(ColdRequest[I#]) > 127
                   ColdRequest[I#] = ' '
              END
            END
            ColdResp = ''
            ColdTopic = CLIP(ColdRequest)
            DDEREAD(ColdChannel,DDE:Manual,ColdTopic,ColdResp) ! Get the Topic from the server
!            ColdLines# += 1
!            IF ColdLines# > 4    ! display only the last 4 responses
!              CRLF1# = INSTRING('<13,10>',ColdText,1)
!              ColdText = SUB(ColdText,CRLF1#+2,SIZE(ColdText))
!            END
!            ColdText = CLIP(ColdText) & CrLf & ColdResp
            ColdText = ColdResp
            DISPLAY(?ColdText)
            SELECT(?ColdRequest)



          OF ?ColdCommand

          OF ?ExecButton
            IF ~ColdChannel          ! If current link
              SELECT(?ColdServer)    ! get one
              CYCLE
            ELSIF ~ColdCommand       ! If no Command given
              SELECT(ColdCommand)    ! get one
              CYCLE
            END
            LOOP I# = 1 TO LEN(CLIP(ColdCommand)) ! correct bad chars derived from "CLIPBOARD PASTE" operation
              IF VAL(ColdCommand[I#]) < 32 OR |
                 VAL(ColdCommand[I#]) > 127
                   ColdCommand[I#] = ' '
              END
            END
            ColdCommand = CLIP(ColdCommand)
            DDEExecute(ColdChannel,ColdCommand) ! Send the Command to the server
            SELECT(?ColdCommand)

        END

      OF EVENT:CloseWindow
        Break
    END
  END
  IF ColdChannel               ! If link exists
    DDEClose(ColdChannel)      ! close it
  END
  FREE(Server:Queue)           ! Free the server queue
  FREE(Item:Queue)             ! Free the item queue
  CLOSE(ColdClientScr)
  DDECC = 0                    ! turn off COLD Client active flag


LoadServerQueue     ROUTINE    ! Load the Server Queue with "Active" Servers
  FREE(Server:Queue)           ! Returns: Srvr1:Topic,Srvr2:Topic,...
  ColdResp = DDEQUERY()
  ColdResp = CLIP(ColdResp) & ','  ! Add a comma to the end so all "sets" end with a comma
  N# = 1                                  ! start at pos 1
  LOOP
    C# = INSTRING(',',ColdResp,1,N#)      ! find the next comma
    IF ~C#; BREAK.                        ! if not one, we're done
    S# = INSTRING(':',ColdResp,1,N#)      ! find where Srvr name ends
    SER:ServerID    = ColdResp[N#:S#-1]   ! use "string slicing" to get server name
    SER:ServerTopic = ColdResp[S#+1:C#-1] ! use "string slicing" to get server topic
    SER:ServerChannel = 0
    SER:ServerActive = ''
    ADD(Server:Queue)                     ! add the server info to the queue
    N# = C#+1                             ! point to pos after the comma
  END
  SER:ServerID    = 'ProgMan'             ! add Program Manager to the queue
  SER:ServerTopic = 'ProgMan'
  SER:ServerChannel = 0
  SER:ServerActive = ''
  ADD(Server:Queue)
  ColdResp = ''
  SORT(Server:Queue,SER:ServerID)         ! sort the queue by ServerID(NAME) major
  SORT(Server:Queue,SER:ServerTopic)      ! sort the queue by Server Topic minor
