  PROGRAM

!*******************************************************
! DDE SERVER Demo Program by:
! Larry Teames
! CREATIVE PC SOLUTIONS
! CIS: 73150,104
! (602) 963-3506
!*******************************************************


CrLf     EQUATE('<13,10>')

 INCLUDE('EQUATES.CLW')
 INCLUDE('KEYCODES.CLW')


    map
      ColdServerProc                  ! COLD Server
      HotServerProc                   ! HOT Server
!      INCLUDE('WINDOWS.CLW')
      INCLUDE('DDE.CLW')
!      MODULE('Win API')
!        FindWindow(*CSTRING,*CSTRING),SHORT,RAW,PASCAL ! Find if App running
!      END
    END



BaseScreen APPLICATION('DDE SERVER Demo'),AT(180,0,180,220),FONT('Arial',10,,FONT:regular),HLP('DDE Library Reference'), |
         SYSTEM,DOUBLE
       MENUBAR
         MENU('&Windows'),STD(STD:WindowList)
           ITEM('&Tile'),USE(?Tile),STD(STD:TileWindow)
           ITEM('&Cacade'),USE(?Cascade),STD(STD:CascadeWindow)
         END
         MENU('&Help'),LAST,MSG('Windows Help')
           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
         END
       END
       TOOLBAR,AT(0,0,180,17)
         BUTTON('&COLD Server'),AT(2,1,52,15),USE(?StartColdServer)
         BUTTON('&HOT Server'),AT(61,1,52,15),USE(?StartHotServer)
         BUTTON('&Start Clients'),AT(117,1,58,15),USE(?StartClient)
       END
     END


WINCLASS          CSTRING(80)    ! Used by FindWindow()
WINTITLE          CSTRING(80)    ! Used by FindWindow()


SERVER2Channel    LONG           ! HOT server channel
SERVER2Pkt        STRING(40)     ! string used to send HOT server data to clients


SERVER1Channel    LONG           ! COLD server channel
SERVER1Pkt        STRING(40)     ! string used to send COLD server data to clients


CmdLine           CSTRING(32)    ! used by WinEXEC()
WinExecStat       USHORT         ! used by WinExec()


CST               BYTE           ! COLD Server Thread no
HST               BYTE           ! HOT Server Thread no

  CODE

  OPEN(BaseScreen)

  HELP('CWHELP.HLP')  ! default HELP to DDE Info

  ACCEPT

    CASE EVENT()
      OF EVENT:OpenWindow
        WINCLASS = 'ClaWinClass1'               ! set the "Class" name,
        WINTITLE = 'DDE CLIENT Demo'            ! set the "Title" name,
        CDEMO# = FindWindow(WINCLASS, WINTITLE) ! is DDEDEMOC.EXE running?
        IF ~CDEMO#                              ! If not:
          CASE MESSAGE('Start the CLIENT Application?','DDE SERVER Demo',ICON:Question,BUTTON:Yes+BUTTON:No,BUTTON:Yes) ! ask user
            OF BUTTON:Yes                           ! if user answers Yes
              CmdLine = 'DDEDEMOC.EXE'
              WinExecStat = WinExec(CmdLine,2)      ! Start the Server App
              IF WinExecStat < 32
                X# = MESSAGE('Unable to start DDEDEMOC.EXE','Problem',ICON:Exclamation,BUTTON:Ok)
              END
          END
        END

    END

    CASE ACCEPTED()
      OF ?StartColdServer
        IF ~SERVER1Channel             ! If COLD Server not running
          CST = START(ColdServerProc)  ! try to start it
        ELSE
          X# = MESSAGE('"COLD" Server is already running','Information',ICON:Exclamation)
        END


      OF ?StartHotServer
        IF ~SERVER2Channel             ! If HOT Server not running
          HST = START(HotServerProc)   ! try to start it
        ELSE
          X# = MESSAGE('"HOT" Server is already running','Information',ICON:Exclamation)
        END


      OF ?StartClient
        WINCLASS = 'ClaWinClass1'               ! set the "Class" name,
        WINTITLE = 'DDE CLIENT Demo'            ! set the "Title" name,
        CDEMO# = FindWindow(WINCLASS, WINTITLE) ! is DDEDEMOC.EXE running?
        IF ~CDEMO#
          CmdLine = 'DDEDEMOC.EXE'
          WinExecStat = WinExec(CmdLine,2)      ! No, try to start it
          IF WinExecStat < 32
            X# = MESSAGE('Unable to start DDEDEMOC.EXE','Problem',ICON:Exclamation,BUTTON:Ok)
          END
        ELSE
          X# = MESSAGE('DDEDEMOC.EXE is already running','Information',ICON:Exclamation)
        END

    END
  END



HotServerProc     PROCEDURE

SendFreq        BYTE

HotServerScreen WINDOW('DDE "HOT" Server'),AT(1,125,176,30),FONT('Arial',10,,400),SYSTEM,GRAY,STATUS(80,110),TIMER(100)
         BUTTON('&Set'),AT(146,6,20,14),USE(?SendFreqChange)
         PROMPT('Send Frequency (in seconds):'),AT(11,8,,),USE(?Prompt1)
         SPIN(@N1),AT(114,7,19,12),USE(SendFreq),RANGE(1,9),STEP(1)
       END


  CODE

  SendFreq = 2         ! start with HOT Server sending data each 2 seconds

  OPEN(HotServerScreen)

  ACCEPT

    CASE EVENT()
      OF EVENT:OpenWindow
        SERVER2Channel = DDEServer('HotDemo','HotTopic')  ! Start the HOT Server
        IF ~SERVER2Channel
          X# = MESSAGE('Unable to start the "HOT" Server','Problem',ICON:Asterisk)
          RETURN
        END


      OF EVENT:CloseDown
        BREAK

      OF EVENT:Timer
        ! This code simply causes the SERVER2Pkt info to be changed at the
        ! frequency dictated by the TIMER control of the window.  This in
        ! conjunction with the DDEAdvise EVENT below will cause the "CLIENT"
        ! to be sent a data packet as described below.
        !
        IF SERVER2Channel
          PKT# += 1
          SERVER2Pkt = 'HotDemo:HotTopic:HotData: '&PKT#
          TARGET{PROP:StatusText,1} = 'DEVELOPING ' & PKT#
        END


      OF EVENT:DDEAdvise
        ! this code sets the established server to a "HOT" connection which
        ! will send "SERVER2Pkt" to the "HOT" Client at "SendFreq" intervals
        ! *if* the contents of SERVE2Pkt have changed since the last send.
        !
        TARGET{PROP:StatusText,2} = 'Sending at ' & SendFreq & ' Second Intervals'
        DDEWrite(SERVER2Channel,SendFreq,'HotData',SERVER2Pkt)   ! (Re) establish a "HOT" connection at the SendFreq intervals


      OF EVENT:DDEExecute
        ! The Server would use DDEVALUE() to determine the "command" being
        ! requested, and execute whatever procedure is appropriate.
        ! Typically, this might be coded in a CASE DDEVALUE() construct
        ! with choices for each valid "command", or be made of various
        ! IF/THEN/ELSE constructs.
        !
        IF UPPER(SUB(DDEVALUE(),1,7)) = 'COMMAND'
          X# = MESSAGE('DDE Command "' & SUB(DDEValue(),8,10) & '" received','DDE HOT Server',ICON:Exclamation)
          CYCLE
        ELSE
          X# = MESSAGE('DDE Command "' & DDEValue() & '" received','DDE HOT Server',ICON:Exclamation)
          CYCLE
        END



      ! EVENT:DDEPoke is generated in a DDE Server when
      ! DDEPOKE() is used by a DDE Client to send "unsolicited data" *to* a
      ! DDE Server.  This allows a DDE Client the ability to "control"
      ! some of the operation of the server by changing the server's
      ! operating environment.  NOTE that the target server must be programmed
      ! to recognize the DDEPOKE Event and that DDEITEM() is used to
      ! determine the "data" being sent and DDEVALUE() returns the actual
      ! "data" value sent.
      !
      OF EVENT:DDEPoke
        CASE DDEITEM()
          OF 'Slower'                        ! DDE Client says "GO SLOWER"
            SendFreq += DDEVALUE()           ! so increase the sendfreq
            IF SendFreq > 9; SendFreq = 9.

          OF 'Faster'                        ! DDE Client says "GO FASTER"
            SendFreq -= DDEVALUE()           ! so decrease the sendfreq
            IF SendFreq < 1; SendFreq = 1.
        END

        POST(EVENT:DDEAdvise)                ! generate a DDEAdvise EVENT
        DISPLAY(?SendFreq)                   ! to "recalibrate" the Hot Server
        CYCLE


      OF EVENT:Accepted
        CASE FIELD()
          OF ?SendFreqChange
            POST(EVENT:DDEAdvise)            ! generate a DDEAdvise EVENT
            SELECT(?SendFreqChange)          ! to "recalibrate" the Hot Server
        END

    END

  END
  DDECLOSE(SERVER2Channel)       ! close the Channel
  SERVER2Channel = 0
  CLOSE(HotServerScreen)
  HST = 0




ColdServerProc     PROCEDURE

ColdServerScreen WINDOW('DDE "COLD" Server'),AT(1,1,176,13),FONT('Arial',10,,400),SYSTEM,GRAY,STATUS
       END


  CODE

  OPEN(ColdServerScreen)

  ACCEPT

    CASE EVENT()

      OF EVENT:DDEExecute
        ! The Server would use DDEVALUE() to determine the "command" being
        ! requested, and execute whatever procedure is appropriate.
        ! Typically, this might be coded in a CASE DDEVALUE() construct
        ! with choices for each valid "command", or be made of various
        ! IF/THEN/ELSE constructs.
        !
        IF UPPER(SUB(DDEVALUE(),1,7)) = 'COMMAND'
          X# = MESSAGE('DDE Command "' & SUB(DDEValue(),8,10) & '" received','DDE COLD Server',ICON:Exclamation)
        ELSE
          X# = MESSAGE('DDE Command "' & DDEValue() & '" received','DDE COLD Server',ICON:Exclamation)
        END


      OF EVENT:OpenWindow             ! When the window opens
        SERVER1Channel = DDEServer('ColdDemo','ColdTopic') ! Start the COLD server
        IF ~SERVER1Channel                                 ! If unsuccessful, report it
          X# = MESSAGE('Unable to start the "COLD" Server','Problem',ICON:Asterisk)
          RETURN
        END

      OF EVENT:DDERequest     ! If a Client has requested data
        SERVER1Pkt = ''       ! clear the outgoing data packet
        CASE DDEITEM()        ! determine what data is requested
          OF 'SysItems'       ! if 'SysItems'
            SERVER1Pkt = 'ColdData1   ColdData2'   ! tell what's suported

          OF 'ColdData1'                           ! otherwise
            PKT1# += 1                             ! build the data packet
            SERVER1Pkt = 'ColdData1 Item: '&PKT1#
          OF 'ColdData2'
            PKT2# += 1
            SERVER1Pkt = 'ColdData2 Item: '&PKT2#
        END
        DDEWrite(SERVER1Channel,DDE:Manual,DDEITEM(),SERVER1Pkt) ! and send the data packet to the client
        TARGET{PROP:StatusText} = '"' & CLIP(SERVER1Pkt) & '" sent'

      OF EVENT:CloseDown
        BREAK

    END

  END
  DDECLOSE(SERVER1Channel)    ! close the channel
  SERVER1Channel = 0
  CLOSE(ColdServerScreen)
  CST = 0


