// easybar.h

#ifndef __EASYBAR_H__
#define __EASYBAR_H__

// barcode types:
#define BCT_EAN13			1
#define BCT_EAN8			2
#define BCT_UPCA			3
#define BCT_CODABAR			5
#define BCT_3OF9			6
#define BCT_2OF5			7
#define BCT_INTERLEAVED2OF5	8  
#define BCT_UPCE			9
#define BCT_EAN13_2			10
#define BCT_EAN13_5			11
#define BCT_EAN8_2			12
#define BCT_EAN8_5			13
#define BCT_UPCA_2			14
#define BCT_UPCA_5			15
#define BCT_UPCE_2			16
#define BCT_UPCE_5			17
#define BCT_EAN128A			18
#define BCT_EAN128B			19
#define BCT_EAN128C			20
#define BCT_CODE93			21

// draw flags:
#define BDF_LEFT				0x01
#define BDF_RIGHT				0x02
#define BDF_CENTER				0x04
#define BDF_UNIBARHEIGHT		0x10
#define BDF_HIDEMAINTEXT		0x20
#define BDF_HIDEADDONTEXT		0x40
#define BDF_ADDONTEXTATTOP		0x80
#define BDF_ADDONTEXTATBOTTOM	0x100
#define BDF_MAINTEXTATTOP		0x200
#define BDF_MAINTEXTATBOTTOM	0x400
#define BDF_NOUPCSMALLFONT		0x800
#define BDF_RETAINASPECTRATIO	0x1000
#define BDF_TOP					0x2000
#define BDF_BOTTOM				0x4000
#define BDF_VCENTER				0x8000
#define BDF_CALCSIZEONLY		0x10000
#define BDF_NOPIXELALIGN		0x20000
#define BDF_NOSTRETCHTEXT		0x40000

// clear area IDs:
#define BGCA_LEFT		1
#define BGCA_TOP		2
#define BGCA_RIGHT		3
#define BGCA_BOTTOM		4
#define BGCA_MIDDLE		5

typedef HLOCAL HBARCODE;

int FAR PASCAL EnumBarcodeTypes(int iPos, LPINT lpiType, LPSTR FAR *lplpName);

HBARCODE FAR PASCAL BarCreate(int iBarcodeType, UINT uStyle);
void FAR PASCAL BarDestroy(HBARCODE hBarcode);

BOOL FAR PASCAL BarSetData(HBARCODE hBarcode, LPSTR lpData, int cbData,
				LPSTR lpMsg, int cbMsg);
BOOL FAR PASCAL BarSetAddOnData(HBARCODE hBarcode, LPSTR lpData, int cbData,
				LPSTR lpMsg, int cbMsg);
BOOL FAR PASCAL BarGetData(HBARCODE hBarcode, LPSTR lpszData, int cbMaxData,
					LPSTR lpszMsg, int cbMaxMsg);
BOOL FAR PASCAL BarGetAddOnData(HBARCODE hBarcode, LPSTR lpszData, int cbMaxData,
					LPSTR lpszMsg, int cbMaxMsg);

BOOL FAR PASCAL BarDraw(HBARCODE hBarcode, HDC hdcDraw, HDC hicTarget, 
							LPRECT lpRect, int iOrient, DWORD dwFlags);

BOOL FAR PASCAL BarGetRect(HBARCODE hBarcode, LPRECT lpRect);
BOOL FAR PASCAL BarGetMainBarRect(HBARCODE hBarcode, LPRECT lpRect);
BOOL FAR PASCAL BarGetAddOnRect(HBARCODE hBarcode, LPRECT lpRect);

int FAR PASCAL BarGetModuleCount(HBARCODE hBarcode);

int FAR PASCAL BarGetClearArea(HBARCODE hBarcode, int iClearAreaID);
int FAR PASCAL BarSetClearArea(HBARCODE hBarcode, 
					int iClearAreaID, int iNumNarrowBars);

int FAR PASCAL BarGetNumBarExts(HBARCODE hBarcode);
int FAR PASCAL BarGetBarExt(HBARCODE hBarcode, int iBarIndex);
int FAR PASCAL BarSetBarExt(HBARCODE hBarcode, int iBarIndex, int iNumModules);

int FAR PASCAL BarGetNumSpaceExts(HBARCODE hBarcode);
int FAR PASCAL BarGetSpaceExt(HBARCODE hBarcode, int iSpaceIndex);
int FAR PASCAL BarSetSpaceExt(HBARCODE hBarcode, int iSpaceIndex, int iNumModules);

int FAR PASCAL BarGetInterCharExt(HBARCODE hBarcode);
int FAR PASCAL BarSetInterCharExt(HBARCODE hBarcode, int iNumModules);

#endif
