{------------------------------------------------------}
{ Name :
   RISCHED.PAS Written 21/01/93 - MJE                  }

{ Author :
   Martin Edge

{ Called By :
   The scheduler

{ History :
{             Lots of mods/enhancements 22/01/93 -     }
{                                       24/05/93 - MJE }
{            Version 3.00 (Ensure same as WBSCHED.EXE  }
{             Added version number function      - MJE
                                        10/01/94       }
{------------------------------------------------------}
{ RISCHED.DLL contains one procedure, this procedure will open, or create
  if needed, a file on a shared drive for the remote instructions for the scheduler system.
  The procedure call has the syntax :
  Risend(DriveLetter, Workstation, RemoteInstruction) : Integer
  Where
   DriveLetter is the letter of the shared drive ( 1 character) 
   Workstation is the remote workstation identifier ie the one the instruction is going to
   RemoteInstruction is the instruction itself.
  Returns
   0 if successful and 1 if not.
  }

{$R RISCHED.RES }

Library RISCHED;
{$R- }
Uses
 Strings,WinProcs,WinTypes;

Type
  RemoteInstructionType = Array[0..255] of char;
  DriveLetterType       = Array[0..9] of char;

Const
  ScheduleFileName = '\WINBOX\RISEND.';
  NewLine          : Array[0..2] of char = #13+#10;

Function RiSchedVersion : Integer; Export;
   begin
   RiSchedVersion := 300;
   end;


Function Risend(DriveLetter : DriveLetterType;
                Workstation : Integer;
                RemoteInstruction : RemoteInstructionType) : Integer; export;
Var
   Ext        : String[3]; { File extension }
   SchedFile  : Integer;   { File handle. }
   ReOpenBuff : TOfStruct; { Required for _LOpen function }
   FileName   : String;    { Filename }
   File_PChar_Name : Array[0..100] of char; { File name in a form _LOpen can use }
   I               : Byte;

   begin
   { Build the file name }
   SchedFile := WorkStation;
   Str(SchedFile,Ext);
   If Length(Ext) < 3 then
      repeat
       Ext := '0' + Ext;
      until Length(Ext) = 3;
   FileName := '';
   I := 0;
   Repeat
    If upcase(DriveLetter[I]) in ['A'..'Z'] then
       FileName := DriveLetter[I] + ':'
      else
       Inc(I);
   Until (I >= 8 ) or (upcase(DriveLetter[I]) In ['A'..'Z']);
   FileName := FileName + ScheduleFileName + Ext;
   StrPCopy(File_Pchar_Name,FileName);

   { Check to see if the file exists }
   SchedFile := OpenFile(File_PChar_Name,ReOpenBuff,OF_EXIST);
   If SchedFile < 0 then
      begin 
      SchedFile := OpenFile(File_PChar_Name,ReOpenBuff,OF_CREATE);
      _lClose(SchedFile);
      end;

   { Open the file }
   SchedFile := OpenFile(File_PChar_Name,ReOpenBuff,OF_READWRITE); 

   If SchedFile > 0 then
      Begin
      _llSeek(SchedFile,0,2);
      StrCat(RemoteInstruction,NewLine);
      _lWrite(SchedFIle,RemoteInstruction,StrLen(RemoteInstruction));
      RiSend := 0; { Return 0 if successful }
      end
     Else
      RiSend := 1; { 1 if not }

   _lClose(SchedFile); 

   end;


Exports
       RiSchedVersion Index 2,
       Risend         Index 1;

begin
end.