/***************************************************************

   Copyright 1993  Northeast Data Corp.  All Rights Reserved

****************************************************************/

/***************************************************************


   slider.H

   Public definitions for applications that use the slider.
    - Messages
    - Notification codes.
    - Control Styles.

   Version 1.0, August 1993, Wade Cobb

****************************************************************/

   //Control-specific messages
#define SCM_SETRANGE           (WM_USER+1)
#define SCM_GETRANGE           (WM_USER+2)
#define SCM_GETPOS             (WM_USER+3)
#define SCM_SETPOS             (WM_USER+4)
#define SCM_SETWIDTH           (WM_USER+5)
#define SCM_SETBITMAP          (WM_USER+6)
#define SCM_SETBEVELSTYLE      (WM_USER+7)
#define SCM_SETTICKSTYLE       (WM_USER+8)

   // Bitmaps specified in wParam for SCM_SETBITMAP message
#define SCB_THUMB             0
#define SCB_THUMBFOCUS        1
#define SCB_BEZEL             2

   // Tick styles (used in wParam for SCM_SETTICKSTYLE message)
#define SCTICK_NORMAL         0
#define SCTICK_INSET          1
#define SCTICK_RAISED         2

   // Which bevel to set (wParam) in the SCM_SETBEVELSTYLE message AND
   //  which width to set the the SCM_SETWIDTH message
#define SCBEVEL_INNER         0
#define SCBEVEL_OUTER         1
#define SCBORDER              3

   // Border and bevel styles specified in lParam for SCM_SETBEVELSTYLE 
   //  message
#define SCS_NONE              0
#define SCS_INSET             1
#define SCS_RAISED            2
#define SCS_FRAME             3

   // The one callable function to force the DLL to load
void FAR PASCAL registerSlider(void);

   //Notification codes sent via WM_COMMAND from the control
#define SCN_RANGECHANGE     1
#define SCN_THUMBUP         2

   //Control specific styles specified in CreateWindow call
#define SCS_VERTICAL        0x0001L
#define SCS_HORIZONTAL      0x0002L
#define SCS_TEXTHASRANGE    0x0008L
#define SCS_INVERTRANGE     0x0010L
#define SCS_LEFTTICKS       0x0020L
#define SCS_TOPTICKS        0x0020L
#define SCS_RIGHTTICKS      0x0040L
#define SCS_BOTTOMTICKS     0x0040L
#define SCS_TABSTOP         0x0080L
